#include <fstream>
#include <iostream>
using namespace std;

const int MAXN = 10;
const int MAXL = 100;

enum Tipo {PRIMO, SECONDO, CONTORNO, DOLCE};

struct Ordine {
  char nome[MAXL];
  int tav;
  Tipo tipo;
  int quanti;
};

struct CodaOrdini {
  Ordine ord[MAXN];
  int front, back;
};

bool salva(const CodaOrdini* pc, const char nf[]);
int ordinaPerTavolo(const CodaOrdini* pc, Ordine vv[]);
bool pronto(CodaOrdini* pc, char nome[]);
void quantePorzTipo(const CodaOrdini* pc, int nn[]);
bool piuPorzioni(const CodaOrdini* pc, Ordine* po);

bool inserisci(CodaOrdini* pc, char n[], int t, Tipo p, int q) {
  Ordine o;
  strcpy(o.nome, n);
  o.tav = t;
  o.tipo = p;
  o.quanti = q;
  if ((pc->back + 1) % MAXN == pc->front)
    return false;
  pc->ord[pc->back] = o;
  pc->back = (pc->back + 1) % MAXN;
  return true;
}

void stampaTipo(Tipo t) {
  switch(t) {
    case PRIMO:
      cout << "primo";
      break;
    case SECONDO:
      cout << "secondo";
      break;
    case CONTORNO: 
      cout << "contorno";
      break;
    case DOLCE:
      cout << "dolce";
      break;
  }
}

void stampaOrd(Ordine o) {
  cout << o.nome << " ("; 
  stampaTipo(o.tipo);
  cout << ") per " << o.quanti << ", tav.=" <<
          o.tav << endl;
}

void stampaCoda(const CodaOrdini* pcr){
  for(int i=pcr->front; i!=pcr->back; i=(i+1)%MAXN)
    stampaOrd(pcr->ord[i]);
}


int main(){
  CodaOrdini co;
  co.front = co.back = 0;
  
  inserisci(&co, "tortelli al ragu", 3, PRIMO, 2);
  inserisci(&co, "cinghiale in umido", 1, SECONDO, 1);
  inserisci(&co, "tiramisu", 3, DOLCE, 2);
  inserisci(&co, "tagliatelle ai funghi", 2, PRIMO, 3);
  inserisci(&co, "acquacotta", 2, PRIMO, 2);
  inserisci(&co, "fiorentina", 4, SECONDO, 1);
  inserisci(&co, "patate al forno", 4, CONTORNO, 2);
  inserisci(&co, "gnocchi alla sorrentina", 2, PRIMO, 5);
  inserisci(&co, "crostata", 4, DOLCE, 2);
  inserisci(&co, "pollo alla cacciatora", 1, DOLCE, 2);

  cout << "Stato della coda degli ordini:" << endl;
  stampaCoda(&co);
  system("pause");
  
  int qq[4];
  cout << "Conto il numero di porzioni per tipo:" << endl;
  quantePorzTipo(&co, qq);
  for(int i=PRIMO; i<=DOLCE; i++) {
    cout << qq[i] << ' ';
    stampaTipo((Tipo) i);
    cout << endl;
  }
  system("pause");

  cout << "Salvo lo stato della coda nel file coda.txt" << endl;
  if(salva(&co, "coda.txt")) cout << "Salvataggio riuscito" << endl;
  else cout << "Problemi nel salvataggio" << endl;
  cout << "Contenuto del file:" << endl;
  system("type coda.txt");
  system("pause");

  cout << "L'ordine in cui bisogna preparare piu' porzioni e':" << endl;
  Ordine oo;
  if(piuPorzioni(&co, &oo)) stampaOrd(oo);
  else cout << "sembra che la coda sia vuota..." << endl;
  system("pause");

  cout << "Chiamo la funzione ordinaPerTavolo():" << endl;
  Ordine vet[MAXN];
  int z = ordinaPerTavolo(&co, vet);
  for(int i=0; i<z; i++)
    stampaOrd(vet[i]);
  system("pause");

  cout << "Il cinghiale in umido e' pronto" << endl;
  if(pronto(&co, "cinghiale in umido")) cout << "eliminato dalla coda" << endl;
  else cout << "piatto non trovato" << endl;
  cout << "Stato della coda degli ordini:" << endl;
  stampaCoda(&co);
  system("pause");
  cout << "\nLe patate al forno sono pronte" << endl;
  if(pronto(&co, "patate al forno")) cout << "eliminate dalla coda" << endl;
  else cout << "piatto non trovato" << endl;
  cout << "Stato della coda degli ordini:" << endl;
  stampaCoda(&co);
  system("pause");
  
  return 0;
}
