#include <fstream>
using namespace std;

const int MAXN = 10;
const int MAXL = 100;

enum Tipo {PRIMO, SECONDO, CONTORNO, DOLCE};

struct Ordine {
  char nome[MAXL];
  int tav;
  Tipo tipo;
  int quanti;
};

struct CodaOrdini {
  Ordine ord[MAXN];
  int front, back;
};


bool salva(const CodaOrdini* pc, const char nf[]) {
  fstream ff;
  ff.open(nf, ios::out);
  if(!ff) return false;
  for(int i=pc->front; i != pc->back; i = (i+1)%MAXN)
    ff << pc->ord[i].nome << " x " << pc->ord[i].quanti << ", tav. " << pc->ord[i].tav << endl;
  return true;
}


void scambia(Ordine r[], int x, int y) {
    Ordine lav = r[x];
    r[x] = r[y];
    r[y] = lav;
}

void ordina(Ordine v[], int n) {
  bool ordinato = false;
  for(int i = 0; i < n-1 && !ordinato; i++) {
    ordinato = true;
    for(int j = n-1; j >= i+1; j--)
      if(v[j].tav < v[j-1].tav) {
        scambia(v, j, j-1);
        ordinato = false;
      }
  }
}

int ordinaPerTavolo(const CodaOrdini* pc, Ordine vv[]) {
  int conta = 0;
  for(int i=pc->front; i != pc->back; i = (i+1)%MAXN)
    vv[conta++] = pc->ord[i];
  ordina(vv, conta);
  return conta;
}

bool pronto(CodaOrdini* pc, char nome[]) {
  for(int i=pc->front; i != pc->back; i = (i+1)%MAXN)
    if(strcmp(pc->ord[i].nome, nome)==0) {
      if(--pc->ord[i].quanti<=0) {
        for(int j=i; j !=pc->back-1; j = (j+1)%MAXN)
          pc->ord[j] = pc->ord[j+1];
        pc->back = (pc->back == 0 ? MAXN - 1 : pc->back - 1);
      }
      return true;
    }
  return false;
}

void quantePorzTipo(const CodaOrdini* pc, int nn[]) {
  for(int i=PRIMO; i<=DOLCE; i++) 
    nn[i] = 0;
  for(int i=pc->front; i != pc->back; i = (i+1)%MAXN)
    nn[pc->ord[i].tipo]+=pc->ord[i].quanti;
}

bool piuPorzioni(const CodaOrdini* pc, Ordine* po){
  int max = 0;
  for(int i=pc->front; i != pc->back; i = (i+1)%MAXN)
    if(pc->ord[i].quanti > max) {
      max = pc->ord[i].quanti;
      *po = pc->ord[i];
    }
  return max!=0;
}

